#Class that uses bluetooth to communicate with HC-06
#https://github.com/pybluez/pybluez
#https://github.com/pybluez/pybluez/blob/master/examples/simple/rfcomm-server.py

import bluetooth

class Hardware_interface:
    
    #def __init__(self):
    
    def __del__(self):
        #Destructor used to close the socket
        self.client_socket.close()
        self.server_socket.close()
        print("All done.")

    #Print device list to check names used by the system. Used for debugging purposes
    def print_device_list(self):
        nearby_devices = bluetooth.discover_devices(lookup_names=True)
        print("Found {} devices.".format(len(nearby_devices)))

        for addr, name in nearby_devices:
            print("  {} - {}".format(addr, name))    

    def start_server(self):
        self.server_socket = bluetooth.BluetoothSocket(bluetooth.RFCOMM)
        self.server_socket.bind(("", bluetooth.PORT_ANY))
        self.server_socket.listen(1)
        
        port = self.server_socket.getsockname()[1]

        uuid = "94f39d29-7d6d-437d-973b-fba39e49d4ee"

        bluetooth.advertise_service(self.server_socket, "SampleServer", service_id=uuid,
                            service_classes=[uuid, bluetooth.SERIAL_PORT_CLASS],
                            profiles=[bluetooth.SERIAL_PORT_PROFILE],
                            # protocols=[bluetooth.OBEX_UUID]
                            )

        print("Waiting for connection on RFCOMM channel", port)

        self.client_socket, self.client_info = self.server_socket.accept()
        print("Accepted connection from", self.client_info)

    #Send data using bluetooth interface
    def send_data(self, data):
        self.client_socket.send(data)

    #Get data from Bluetooth. Returns a tuple (Bool, CharArray). Boolean = True means data was received
    def get_data(self):
        try:
            data = None
            dataAvaialble = True
            self.client_socket.settimeout(10)
            data = self.client_socket.recv(1024)
            print(data)
            if not data:
                dataAvaialble = False
        except OSError:
            return 0, data
        except:
            print("Time out")
            return 0, data
        return 1, data